VirtualBox

source: vbox/trunk/configure@ 31036

Last change on this file since 31036 was 31036, checked in by vboxsync, 14 years ago

configure: missing call to XCloseDisplay

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 65.6 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2009 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 sunos)
55 OS='solaris'
56 ;;
57 *)
58 echo "Cannot determine OS!"
59 exit 1
60 ;;
61esac
62
63#
64# Defaults
65#
66OSE=1
67ODIR="`pwd`/"
68ODIR_OVERRIDE=0
69OUT_PATH=""
70OUT_PATH_OVERRIDE=0
71SETUP_WINE=
72TARGET_MACHINE=""
73TARGET_CPU=""
74WITH_XPCOM=1
75WITH_PYTHON=1
76WITH_JAVA=1
77WITH_VMMRAW=1
78WITH_LIBIDL=1
79WITH_GSOAP=0
80WITH_QT4=1
81WITH_SDL=1
82WITH_SDL_TTF=1
83WITH_X11=1
84WITH_ALSA=1
85WITH_PULSE=1
86WITH_DBUS=1
87WITH_KMODS=1
88WITH_OPENGL=1
89WITH_HARDENING=1
90WITH_VDE=0
91BUILD_LIBXML2=
92BUILD_LIBXSLT=
93BUILD_LIBCURL=
94BUILD_LIBSSL=
95PASSIVE_MESA=0
96CC="gcc"
97CC32=""
98CC64=""
99CXX="g++"
100CXX32=""
101CXX64=""
102BCC="bcc"
103YASM="yasm"
104IASL="iasl"
105AS86="as86"
106XSLTPROC="xsltproc"
107GENISOIMAGE="genisoimage"
108MKISOFS="mkisofs"
109INCCRYPTO=""
110LIBCRYPTO="-lcrypto"
111LIBPTHREAD="-lpthread"
112LIBCAP="-lcap"
113GSOAP=""
114GSOAP_IMPORT=""
115INCX11="/usr/local/include"
116LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
117LIBXCURSOR="-lXcursor"
118LIBXMU="-lXmu"
119LIBXINERAMA="-lXinerama"
120LIBXRANDR="-lXrandr"
121MESA="-lGL"
122INCZ=""
123LIBZ="-lz"
124INCPNG=""
125LIBPNG="-lpng"
126CXX_FLAGS=""
127if [ "$OS" = "freebsd" ]; then
128 INCCURL="-I/usr/local/include"
129 LIBCURL="-L/usr/local/lib -lcurl"
130 INCPULSE="-I/usr/local/include"
131 LIBPULSE="-L/usr/local/lib"
132else
133 INCCURL=""
134 LIBCURL="-lcurl"
135fi
136PKGCONFIG="`which_wrapper pkg-config`"
137PYTHONDIR="/usr /usr/local"
138QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
139QT4DIR_PKGCONFIG=1
140QT4UIC3DIR="/usr/bin"
141KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
142DEVDIR="`cd \`dirname $0\`; pwd`/tools"
143if [ -d "/lib/modules/`uname -r`/build" ]; then
144 LINUX="/lib/modules/`uname -r`/build"
145else
146 LINUX="/usr/src/linux"
147fi
148KCHMVIEWER="kchmviewer"
149LOG="configure.log"
150CNF="AutoConfig.kmk"
151ENV="env.sh"
152BUILD_TYPE="release"
153# the restricting tool is ar (mri mode).
154INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
155
156if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
157 echo "Error: VBox base path contains invalid characters!"
158 exit 1
159fi
160
161# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
162if [ "$OS" = "darwin" ]; then
163 ECHO_N="/bin/echo -n"
164else
165 ECHO_N="echo -n"
166fi
167
168
169cleanup()
170{
171 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
172}
173
174fail()
175{
176 if [ -z "$nofatal" -o "x$1" != "x" ]; then
177 cleanup
178 rm -f $ENV
179 exit 1
180 fi
181}
182
183log()
184{
185 echo "$1"
186 echo "$1" >> $LOG
187}
188
189log_success()
190{
191 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
192 echo "OK."
193 echo "$1" >> $LOG
194 echo >> $LOG
195 echo >> $LOG
196}
197
198log_failure()
199{
200 echo
201 echo " ** $1!"
202 echo "** $1!" >> $LOG
203 echo >> $LOG
204}
205
206cnf_append()
207{
208 printf "%-30s := %s\n" "$1" "$2" >> $CNF
209}
210
211strip_l()
212{
213 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
214}
215
216strip_L()
217{
218 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
219}
220
221strip_I()
222{
223 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
224}
225
226prefix_I()
227{
228 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
229}
230
231check_avail()
232{
233 if [ -z "$1" ]; then
234 log_failure "$2 is empty"
235 fail $3
236 return 1
237 elif which_wrapper $1 > /dev/null; then
238 return 0
239 else
240 log_failure "$1 (variable $2) not found"
241 fail $3
242 return 1
243 fi
244}
245
246
247# Prepare a test
248test_header()
249{
250 echo "***** Checking $1 *****" >> $LOG
251 $ECHO_N "Checking for $1: "
252}
253
254
255# Compile a test
256# $1 compile flags/libs
257# $2 library name
258# $3 package name
259# $4 if this argument is 'nofatal', don't abort
260test_compile()
261{
262 echo "compiling the following source file:" >> $LOG
263 cat $ODIR.tmp_src.cc >> $LOG
264 echo "using the following command line:" >> $LOG
265 echo "$CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
266 $CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
267 if [ $? -ne 0 ]; then
268 if [ -z "$4" ]; then
269 echo
270 echo " $2 not found at $1 or $3 headers not found"
271 echo " Check the file $LOG for detailed error information."
272 fail
273 else
274 echo >> $LOG
275 echo >> $LOG
276 fi
277 return 1
278 fi
279 return 0
280}
281
282
283# Execute a compiled test binary
284test_execute()
285{
286 echo "executing the binary" >> $LOG
287 $ODIR.tmp_out > $ODIR.test_execute.log
288 rc=$?
289 cat $ODIR.test_execute.log | tee -a $LOG
290 if [ $rc -ne 0 ]; then
291 fail $1
292 return 1
293 fi
294 echo >> $LOG
295 echo >> $LOG
296 return 0
297}
298
299
300# Execute a compiled test binary
301test_execute_path()
302{
303 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
304 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
305 rc=$?
306 cat $ODIR.test_execute.log | tee -a $LOG
307 if [ $rc -ne 0 ]; then
308 fail
309 return 1
310 fi
311 echo >> $LOG
312 echo >> $LOG
313 return 0
314}
315
316
317#
318# Check for OS, MACHINE, CPU
319#
320check_environment()
321{
322 test_header environment
323 BUILD_CPU=`uname -m`
324 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
325 case "$BUILD_CPU" in
326 i[3456789]86|x86|i86pc)
327 BUILD_MACHINE='x86'
328 LIB='lib'
329 ;;
330 x86_64|amd64)
331 BUILD_MACHINE='amd64'
332 BUILD_CPU='k8'
333 if [ "$OS" != "solaris" ]; then
334 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
335 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
336 LIB='lib64'
337 else
338 # Solaris doesn't seem to subscribe to fhs, libs are usually in
339 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
340 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
341 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
342 # have to make sure the */bin/amd64 dirs are searched before the */bin
343 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
344 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
345 echo "old PATH: $PATH" >> $LOG
346 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
347 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
348 export PATH
349 echo "new PATH: $PATH" >> $LOG
350 LIB='lib/64'
351 fi
352 ;;
353 *)
354 log_failure "Cannot determine system"
355 exit 1
356 ;;
357 esac
358 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
359 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
360 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
361 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
362
363 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
364 echo "export BUILD_PLATFORM" >> $ENV
365 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
366 echo "export BUILD_PLATFORM_ARCH" >> $ENV
367 echo "BUILD_TARGET=\"$OS\"" >> $ENV
368 echo "export BUILD_TARGET" >> $ENV
369 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
370 echo "export BUILD_TARGET_ARCH" >> $ENV
371 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
372 echo "export BUILD_TARGET_CPU" >> $ENV
373 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
374 echo "export BUILD_TYPE" >> $ENV
375}
376
377#
378# Check for gcc with version >= 3.2.
379# We depend on a working gcc, if we fail terminate in every case.
380#
381check_gcc()
382{
383 test_header gcc
384 if check_avail "$CC" CC really; then
385 cc_ver=`$CC -dumpversion` 2>/dev/null
386 if [ $? -ne 0 ]; then
387 log_failure "cannot execute '$CC -dumpversion'"
388 fail really
389 fi
390 if check_avail "$CXX" CXX really; then
391 cxx_ver=`$CXX -dumpversion` 2>/dev/null
392 if [ $? -ne 0 ]; then
393 log_failure "cannot execute '$CXX -dumpversion'"
394 fail really
395 fi
396 cc_maj=`echo $cc_ver|cut -d. -f1`
397 cc_min=`echo $cc_ver|cut -d. -f2`
398 if [ "x$cc_ver" != "x$cxx_ver" ]; then
399 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
400 fail really
401 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
402 log_success "found version $cc_ver"
403 # gcc-4.0 is allowed for Darwin only
404 elif [ $cc_maj -lt 3 \
405 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
406 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
407 -o \( $cc_maj -eq 4 -a $cc_min -gt 5 \) \
408 -o $cc_maj -gt 4 ]; then
409 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<5"
410 fail really
411 else
412 log_success "found version $cc_ver"
413 fi
414 if [ "$BUILD_MACHINE" = "amd64" ]; then
415 [ -z "$CC32" ] && CC32="$CC -m32"
416 [ -z "$CXX32" ] && CXX32="$CXX -m32"
417 else
418 [ -z "$CC32" ] && CC32="$CC"
419 [ -z "$CXX32" ] && CXX32="$CXX"
420 fi
421 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
422 [ -z "$CC64" ] && CC64="$CC -m64"
423 [ -z "$CXX64" ] && CXX64="$CXX -m64"
424 fi
425 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
426 CC32="undefined"
427 CXX32="undefined"
428 fi
429 if [ "$CC" != "gcc" ]; then
430 cnf_append "TOOL_GCC3_CC" "$CC"
431 cnf_append "TOOL_GCC3_AS" "$CC"
432 cnf_append "TOOL_GCC3_LD" "$CC"
433 cnf_append "TOOL_GXX3_CC" "$CC"
434 cnf_append "TOOL_GXX3_AS" "$CC"
435 fi
436 if [ "$CXX" != "g++" ]; then
437 cnf_append "TOOL_GCC3_CXX" "$CXX"
438 cnf_append "TOOL_GXX3_CXX" "$CXX"
439 cnf_append "TOOL_GXX3_LD" "$CXX"
440 fi
441 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
442 cnf_append "TOOL_GCC32_CC" "$CC32"
443 cnf_append "TOOL_GCC32_AS" "$CC32"
444 cnf_append "TOOL_GCC32_LD" "$CC32"
445 cnf_append "TOOL_GXX32_CC" "$CC32"
446 cnf_append "TOOL_GXX32_AS" "$CC32"
447 fi
448 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
449 cnf_append "TOOL_GCC32_CXX" "$CXX32"
450 cnf_append "TOOL_GXX32_CXX" "$CXX32"
451 cnf_append "TOOL_GXX32_LD" "$CXX32"
452 fi
453 # this isn't not necessary, there is not such tool.
454 if [ -n "$CC64" ]; then
455 cnf_append "TOOL_GCC64_CC" "$CC64"
456 cnf_append "TOOL_GCC64_AS" "$CC64"
457 cnf_append "TOOL_GCC64_LD" "$CC64"
458 cnf_append "TOOL_GXX64_CC" "$CC64"
459 cnf_append "TOOL_GXX64_AS" "$CC64"
460 fi
461 if [ -n "$CXX64" ]; then
462 cnf_append "TOOL_GCC64_CXX" "$CXX64"
463 cnf_append "TOOL_GXX64_CXX" "$CXX64"
464 cnf_append "TOOL_GXX64_LD" "$CXX64"
465 fi
466 # Solaris sports a 32-bit gcc/g++.
467 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
468 [ "$CC" = "gcc" ] && CC="gcc -m64"
469 [ "$CXX" = "g++" ] && CXX="g++ -m64"
470 fi
471 fi
472 fi
473}
474
475
476#
477# Check for the bcc compiler, needed for compiling the BIOS
478#
479check_bcc()
480{
481 test_header bcc
482 if check_avail "$BCC" BCC; then
483 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
484 if [ $? -ne 0 ]; then
485 log_failure "not found"
486 fail
487 else
488 echo "compiling the following source file:" >> $LOG
489 cat > $ODIR.tmp_src.c << EOF
490int foo(a)
491 int a;
492{
493 return 0;
494}
495EOF
496 cat $ODIR.tmp_src.c >> $LOG
497 bcc_path=`which_wrapper $BCC`
498 bcc_dir="`dirname $bcc_path`/"
499 echo "using the following command line:" >> $LOG
500 echo "$BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
501 $BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
502 if [ $? -ne 0 ]; then
503 log_failure "not found"
504 fail
505 else
506 log_success "found version $bcc_ver"
507 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
508 fi
509 unset bcc_path
510 unset bcc_dir
511 fi
512 fi
513}
514
515
516#
517# Check for the as86 assembler, needed for compiling the BIOS
518#
519check_as86()
520{
521 test_header as86
522 if check_avail "$AS86" AS86; then
523 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
524 if [ $? -ne 0 ]; then
525 log_failure "not found"
526 fail
527 else
528 log_success "found version $as86_ver"
529 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
530 fi
531 fi
532}
533
534
535#
536# Check for yasm, needed to compile assembler files
537#
538check_yasm()
539{
540 test_header yasm
541 if check_avail "$YASM" YASM; then
542 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
543 if [ $? -ne 0 ]; then
544 log_failure "not found"
545 fail
546 else
547 yasm_maj=`echo $yasm_ver|cut -d. -f1`
548 yasm_min=`echo $yasm_ver|cut -d. -f2`
549 yasm_rev=`echo $yasm_ver|cut -d. -f3`
550 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
551 if [ $yasm_ver_mul -lt 501 ]; then
552 log_failure "found version $yasm_ver, expected at least 0.5.1"
553 fail
554 else
555 log_success "found version $yasm_ver"
556 fi
557 fi
558 fi
559}
560
561
562#
563# Check for the iasl ACPI compiler, needed to compile vbox.dsl
564#
565check_iasl()
566{
567 test_header iasl
568 if check_avail "$IASL" IASL; then
569 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
570 if [ $? -ne 0 ]; then
571 log_failure "not found"
572 fail
573 else
574 log_success "found version $iasl_ver"
575 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
576 fi
577 fi
578}
579
580
581#
582# Check for xsltproc, needed by Main
583#
584check_xsltproc()
585{
586 test_header xslt
587 if check_avail "$XSLTPROC" XSLTPROC; then
588 xsltproc_ver=`$XSLTPROC --version`
589 if [ $? -ne 0 ]; then
590 log_failure "not found"
591 fail
592 else
593 log_success "found"
594 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
595 fi
596 fi
597}
598
599
600#
601# Check for mkisofs, needed to build the CDROM image containing the additions
602#
603check_mkisofs()
604{
605 test_header mkisofs
606 if which_wrapper $GENISOIMAGE > /dev/null; then
607 mkisofs_ver=`$GENISOIMAGE --version`
608 if [ $? -ne 0 ]; then
609 log_failure "not found"
610 fail
611 else
612 log_success "found $mkisofs_ver"
613 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
614 fi
615 elif check_avail "$MKISOFS" MKISOFS; then
616 mkisofs_ver=`$MKISOFS --version`
617 if [ $? -ne 0 ]; then
618 log_failure "not found"
619 fail
620 else
621 log_success "found $mkisofs_ver"
622 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
623 fi
624 fi
625}
626
627
628#
629# Check for libxml2, needed by VBoxSettings and Runtime.
630# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
631#
632check_libxml2()
633{
634 if [ -z "$BUILD_LIBXML2" ]; then
635 test_header libxml2
636 if which_wrapper pkg-config > /dev/null; then
637 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
638 if [ $? -ne 0 ]; then
639 log_failure "not found"
640 fail
641 else
642 FLGXML2=`pkg-config libxml-2.0 --cflags`
643 INCXML2=`strip_I "$FLGXML2"`
644 LIBXML2=`pkg-config libxml-2.0 --libs`
645 cat > $ODIR.tmp_src.cc << EOF
646#include <cstdio>
647#include <libxml/xmlversion.h>
648extern "C" int main(void)
649{
650 printf("found version %s", LIBXML_DOTTED_VERSION);
651#if LIBXML_VERSION >= 20626
652 printf(", OK.\n");
653 return 0;
654#else
655 printf(", expected version 2.6.26 or higher\n");
656 return 1;
657#endif
658}
659EOF
660 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
661 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
662 if test_execute; then
663 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
664 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
665 fi
666 fi
667 fi
668 elif which_wrapper xml2-config; then
669 libxml2_ver=`xml2-config --version`
670 if [ $? -ne 0 ]; then
671 log_failure "not found"
672 fail
673 else
674 log_success "found version $libxml2_ver"
675 FLGXML2=`xml2-config --cflags`
676 INCXML2=`strip_I "$FLGXML2"`
677 LIBXML2=`xml2-config --libs`
678 cat > $ODIR.tmp_src.cc << EOF
679#include <cstdio>
680#include <libxml/xmlversion.h>
681extern "C" int main(void)
682{
683 printf("found version %s", LIBXML_DOTTED_VERSION);
684#if LIBXML_VERSION >= 20626
685 printf(", OK.\n");
686 return 0;
687#else
688 printf(", expected version 2.6.26 or higher\n");
689 return 1;
690#endif
691}
692EOF
693 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
694 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
695 if test_execute; then
696 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
697 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
698 fi
699 fi
700 fi
701 else
702 log_failure "neither pkg-config nor xml2-config found"
703 fail
704 fi
705 fi
706}
707
708
709#
710# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.15,
711# as Solaris right now has no newer version and it definitely works.
712# 1.1.17 is available on Ubuntu Edgy which fulfils the minimal libxml2
713# requirement (2.6.26).
714#
715check_libxslt()
716{
717 if [ -z "$BUILD_LIBXSLT" ]; then
718 test_header libxslt
719 if which_wrapper pkg-config > /dev/null; then
720 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
721 if [ $? -ne 0 ]; then
722 log_failure "not found"
723 fail
724 else
725 FLGXSLT=`pkg-config libxslt --cflags`
726 INCXSLT=`strip_I "$FLGXSLT"`
727 LIBXSLT=`pkg-config libxslt --libs`
728 cat > $ODIR.tmp_src.cc << EOF
729#include <cstdio>
730#include <libxslt/xsltconfig.h>
731extern "C" int main(void)
732{
733 printf("found version %s", LIBXSLT_DOTTED_VERSION);
734#if LIBXSLT_VERSION >= 10117
735 printf(", OK.\n");
736 return 0;
737#else
738 printf(", expected version 1.1.17 or higher\n");
739 return 1;
740#endif
741}
742EOF
743 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
744 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
745 if test_execute; then
746 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
747 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
748 fi
749 fi
750 fi
751 elif which_wrapper xslt-config; then
752 libxslt_ver=`xslt-config --version`
753 if [ $? -ne 0 ]; then
754 log_failure "not found"
755 fail
756 else
757 log_success "found version $libxslt_ver"
758 FLGXSLT=`xslt-config --cflags`
759 INCXSLT=`strip_I "$FLGXSLT"`
760 LIBXSLT=`xslt-config --libs`
761 cat > $ODIR.tmp_src.cc << EOF
762#include <cstdio>
763#include <libxslt/xsltconfig.h>
764extern "C" int main(void)
765{
766 printf("found version %s", LIBXSLT_DOTTED_VERSION);
767#if LIBXSLT_VERSION >= 10117
768 printf(", OK.\n");
769 return 0;
770#else
771 printf(", expected version 1.1.17 or higher\n");
772 return 1;
773#endif
774}
775EOF
776 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
777 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
778 if test_execute; then
779 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
780 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
781 fi
782 fi
783 fi
784 else
785 log_failure "neither pkg-config nor xslt-config found"
786 fail
787 fi
788 fi
789}
790
791
792#
793# Check for libIDL, needed by xpcom
794#
795check_libidl()
796{
797 test_header libIDL
798
799 if which_wrapper libIDL-config-2 > /dev/null; then
800 libidl_ver=`libIDL-config-2 --version`
801 if [ $? -ne 0 ]; then
802 log_failure "not found"
803 fail
804 else
805 log_success "found version $libidl_ver"
806 cnf_append "VBOX_LIBIDL_CONFIG" \
807 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
808 fi
809 elif check_avail "libIDL-config" libIDL-config; then
810 libidl_ver=`libIDL-config --version`
811 if [ $? -ne 0 ]; then
812 log_failure "not found"
813 fail
814 else
815 log_success "found version $libidl_ver"
816 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
817 fi
818 fi
819}
820
821
822#
823# Check for openssl, needed for RDP and S3
824#
825check_ssl()
826{
827 if [ -z "$BUILD_LIBSSL" ]; then
828 test_header ssl
829 cat > $ODIR.tmp_src.cc << EOF
830#include <cstdio>
831#include <openssl/opensslv.h>
832extern "C" int main(void)
833{
834 printf("found version %s", OPENSSL_VERSION_TEXT);
835#if OPENSSL_VERSION_NUMBER >= 0x00908000
836 printf(", OK.\n");
837 return 0;
838#else
839 printf(", expected version 0.9.8 or higher\n");
840 return 1;
841#endif
842}
843EOF
844 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
845 if test_execute nofatal; then
846 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
847 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
848 fi
849 fi
850 fi
851}
852
853
854#
855# Check for pthread, needed by VBoxSVC, frontends, ...
856#
857check_pthread()
858{
859 test_header pthread
860 cat > $ODIR.tmp_src.cc << EOF
861#include <cstdio>
862#include <pthread.h>
863extern "C" int main(void)
864{
865 pthread_mutex_t mutex;
866 if (pthread_mutex_init(&mutex, NULL)) {
867 printf("pthread_mutex_init() failed\n");
868 return 1;
869 }
870 if (pthread_mutex_lock(&mutex)) {
871 printf("pthread_mutex_lock() failed\n");
872 return 1;
873 }
874 if (pthread_mutex_unlock(&mutex)) {
875 printf("pthread_mutex_unlock() failed\n");
876 return 1;
877 }
878 printf("found, OK.\n");
879}
880EOF
881 if test_compile $LIBPTHREAD pthread pthread; then
882 if test_execute; then
883 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
884 fi
885 fi
886}
887
888
889#
890# Check for zlib, needed by VBoxSVC, Runtime, ...
891#
892check_z()
893{
894 test_header zlib
895 cat > $ODIR.tmp_src.cc << EOF
896#include <cstdio>
897#include <zlib.h>
898extern "C" int main(void)
899{
900 printf("found version %s", ZLIB_VERSION);
901#if ZLIB_VERNUM >= 0x1210
902 printf(", OK.\n");
903 return 0;
904#else
905 printf(", expected version 1.2.1 or higher\n");
906 return 1;
907#endif
908}
909EOF
910 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
911 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
912 if test_execute; then
913 echo "if1of (\$(KBUILD_TARGET),darwin freebsd linux solaris)" >> $CNF
914 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
915 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
916 echo "endif" >> $CNF
917 fi
918 fi
919}
920
921
922#
923# Check for libpng, needed by kchmviewer
924#
925check_png()
926{
927 test_header libpng
928 cat > $ODIR.tmp_src.cc << EOF
929#include <cstdio>
930#include <png.h>
931extern "C" int main(void)
932{
933 printf("found version %s", PNG_LIBPNG_VER_STRING);
934#if PNG_LIBPNG_VER >= 10205
935 printf(", OK.\n");
936 return 0;
937#else
938 printf(", expected version 1.2.5 or higher\n");
939 return 1;
940#endif
941}
942EOF
943 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
944 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
945 if test_execute; then
946 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
947 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
948 fi
949 fi
950}
951
952#
953# Check for libcurl, needed by S3
954#
955check_curl()
956{
957 if [ -z "$BUILD_LIBCURL" ]; then
958 test_header libcurl
959 cat > $ODIR.tmp_src.cc << EOF
960#include <cstdio>
961#include <curl/curl.h>
962extern "C" int main(void)
963{
964 printf("found version %s", LIBCURL_VERSION);
965#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71601
966 printf(", OK.\n");
967 return 0;
968#else
969 printf(", expected version 7.16.1 or higher\n");
970 return 1;
971#endif
972}
973EOF
974 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
975 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
976 if test_execute; then
977 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
978 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
979 fi
980 fi
981 fi
982}
983
984
985#
986# Check for pam, needed by VRDPAuth
987# Version 79 was introduced in 9/2005, do we support older versions?
988# Debian/sarge uses 76
989# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
990#
991check_pam()
992{
993 test_header pam
994 cat > $ODIR.tmp_src.cc << EOF
995#include <cstdio>
996#include <security/pam_appl.h>
997extern "C" int main(void)
998{
999 printf("found version %d", __LIBPAM_VERSION);
1000 if (__LIBPAM_VERSION >= 76)
1001 {
1002 printf(", OK.\n");
1003 return 0;
1004 }
1005 else
1006 {
1007 printf(", expected version 76 or higher\n");
1008 return 1;
1009 }
1010}
1011EOF
1012 if test_compile "-lpam" pam pam nofatal; then
1013 if test_execute nofatal; then
1014 return 0;
1015 fi
1016 fi
1017 echo "not found."
1018 test_header linux_pam
1019 cat > $ODIR.tmp_src.cc << EOF
1020#include <cstdio>
1021#include <security/pam_appl.h>
1022extern "C" int main(void)
1023{
1024 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1025 if (__LINUX_PAM__ >= 1)
1026 {
1027 printf(", OK.\n");
1028 return 0;
1029 }
1030 else
1031 {
1032 printf(", expected version 1.0 or higher\n");
1033 return 1;
1034 }
1035}
1036EOF
1037 if test_compile "-lpam" pam pam; then
1038 test_execute
1039 fi
1040}
1041
1042
1043#
1044# Check for the SDL library, needed by VBoxSDL and VirtualBox
1045# We depend at least on version 1.2.7
1046#
1047check_sdl()
1048{
1049 test_header SDL
1050 if [ "$OS" = "darwin" ]; then
1051 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1052 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1053 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1054 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1055 fi
1056 if [ -n "$PATH_SDK_LIBSDL" ]; then
1057 foundsdl=1
1058 INCSDL="$PATH_SDK_LIBSDL/Headers"
1059 FLDSDL="-framework SDL"
1060 else
1061 log_failure "SDL framework not found"
1062 fail
1063 fi
1064 else
1065 if which_wrapper sdl-config > /dev/null; then
1066 FLGSDL=`sdl-config --cflags`
1067 INCSDL=`strip_I "$FLGSDL"`
1068 LIBSDL=`sdl-config --libs`
1069 LIBSDLMAIN="-lSDLmain"
1070 FLDSDL=
1071 foundsdl=1
1072 fi
1073 fi
1074 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1075 if [ -n "$foundsdl" ]; then
1076 cat > $ODIR.tmp_src.cc << EOF
1077#include <cstdio>
1078#include <SDL.h>
1079#include <SDL_main.h>
1080#undef main
1081extern "C" int main(int argc, char** argv)
1082{
1083 printf("found version %d.%d.%d",
1084 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1085#if SDL_VERSION_ATLEAST(1,2,7)
1086 printf(", OK.\n");
1087 return 0;
1088#else
1089 printf(", expected version 1.2.7 or higher\n");
1090 return 1;
1091#endif
1092}
1093EOF
1094 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1095 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1096 if test_execute; then
1097 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1098 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1099 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1100 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1101 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1102 fi
1103 fi
1104 else
1105 log_failure "not found"
1106 fail
1107 fi
1108}
1109
1110
1111#
1112# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1113#
1114check_sdl_ttf()
1115{
1116 test_header SDL_ttf
1117 cat > $ODIR.tmp_src.cc << EOF
1118#include <cstdio>
1119#include <SDL_ttf.h>
1120#ifndef SDL_TTF_MAJOR_VERSION
1121#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1122#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1123#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1124#endif
1125extern "C" int main(void)
1126{
1127 printf("found version %d.%d.%d",
1128 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1129#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1130 printf(", OK.\n");
1131 return 0;
1132#else
1133 printf(", expected version 2.0.6 or higher\n");
1134 return 1;
1135#endif
1136}
1137EOF
1138 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1139 if ! test_execute nofatal; then
1140 cnf_append "VBOX_WITH_SECURELABEL" ""
1141 fi
1142 else
1143 echo "not found -- disabling VBoxSDL secure label."
1144 cnf_append "VBOX_WITH_SECURELABEL" ""
1145 fi
1146}
1147
1148
1149#
1150# Check for libasound, needed by the ALSA audio backend
1151#
1152check_alsa()
1153{
1154 test_header ALSA
1155 cat > $ODIR.tmp_src.cc << EOF
1156#include <cstdio>
1157#include <alsa/asoundlib.h>
1158extern "C" int main(void)
1159{
1160 printf("found version %d.%d.%d",
1161 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1162#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1163 printf(", OK.\n");
1164 return 0;
1165#else
1166 printf(", expected version 1.0.6 or higher\n");
1167 return 1;
1168#endif
1169}
1170EOF
1171 if test_compile "-lasound" asound asound; then
1172 test_execute
1173 fi
1174}
1175
1176
1177#
1178# Check for PulseAudio
1179#
1180check_pulse()
1181{
1182 test_header "PulseAudio"
1183 cat > $ODIR.tmp_src.cc << EOF
1184#include <cstdio>
1185#include <pulse/version.h>
1186extern "C" int main(void)
1187{
1188 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1189#if PA_API_VERSION >= 9
1190 printf(", OK.\n");
1191 return 0;
1192#else
1193 printf(", expected version 0.9.0 (API version 9) or higher\n");
1194 return 1;
1195#endif
1196}
1197EOF
1198 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1199 test_execute
1200 fi
1201}
1202
1203
1204#
1205# Check for the X libraries (Xext, X11)
1206#
1207check_x()
1208{
1209 test_header "X libraries"
1210 cat > $ODIR.tmp_src.cc << EOF
1211#include <cstdio>
1212#include <X11/Xlib.h>
1213extern "C" int main(void)
1214{
1215 Display *dpy;
1216 int scrn_num;
1217 Screen *scrn;
1218 Window win;
1219
1220 dpy = XOpenDisplay(NULL);
1221 scrn_num = DefaultScreen(dpy);
1222 scrn = ScreenOfDisplay(dpy, scrn_num);
1223 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1224 0, 16, InputOutput, CopyFromParent, 0, NULL);
1225 XDestroyWindow(dpy, win);
1226 XCloseDisplay(dpy);
1227}
1228EOF
1229 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1230 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1231 log_success "found"
1232 fi
1233}
1234
1235
1236#
1237# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1238#
1239check_xcursor()
1240{
1241 test_header Xcursor
1242 cat > $ODIR.tmp_src.cc << EOF
1243#include <cstdio>
1244#include <X11/Xlib.h>
1245#include <X11/Xcursor/Xcursor.h>
1246extern "C" int main(void)
1247{
1248 XcursorImage *cursor = XcursorImageCreate (10, 10);
1249 XcursorImageDestroy(cursor);
1250 return 0;
1251}
1252EOF
1253 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1254 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1255 log_success "found"
1256 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1257 fi
1258}
1259
1260
1261#
1262# Check for the Xinerama library, needed by the Qt GUI
1263#
1264check_xinerama()
1265{
1266 test_header Xinerama
1267 cat > $ODIR.tmp_src.cc << EOF
1268#include <X11/Xlib.h>
1269#include <X11/extensions/Xinerama.h>
1270extern "C" int main(void)
1271{
1272 Display *dpy;
1273 Bool flag;
1274 dpy = XOpenDisplay(NULL);
1275 if (dpy)
1276 {
1277 flag = XineramaIsActive(dpy);
1278 XCloseDisplay(dpy);
1279 }
1280}
1281EOF
1282 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1283 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1284 log_success "found"
1285 fi
1286}
1287
1288
1289#
1290# Check for the Xinerama library, needed by the Qt GUI
1291#
1292check_xrandr()
1293{
1294 test_header Xrandr
1295 cat > $ODIR.tmp_src.cc << EOF
1296#include <X11/Xlib.h>
1297#include <X11/extensions/Xrandr.h>
1298extern "C" int main(void)
1299{
1300 Display *dpy;
1301 Bool flag;
1302 int major, minor;
1303 dpy = XOpenDisplay(NULL);
1304 if (dpy)
1305 {
1306 flag = XRRQueryVersion(dpy, &major, &minor);
1307 XCloseDisplay(dpy);
1308 }
1309}
1310EOF
1311 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1312 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1313 log_success "found"
1314 fi
1315}
1316
1317
1318#
1319# Check for OpenGL
1320#
1321check_opengl()
1322{
1323 # On darwin this is a on/off decision only
1324 if [ "$OS" = "darwin" ]; then
1325 test_header "OpenGL support"
1326 echo "enabled"
1327 cnf_append "VBOX_WITH_CROGL" "1"
1328 else
1329 check_xmu
1330 check_mesa
1331 fi
1332}
1333
1334
1335#
1336# Check for the Xmu library, needed by OpenGL
1337#
1338check_xmu()
1339{
1340 test_header Xmu
1341 cat > $ODIR.tmp_src.cc << EOF
1342#include <cstdio>
1343#include <X11/Xatom.h>
1344#include <X11/Xlib.h>
1345#include <X11/Xutil.h>
1346#include <X11/Xmu/StdCmap.h>
1347extern "C" int main(void)
1348{
1349 Display *dpy;
1350 int scrn_num;
1351 Screen *scrn;
1352
1353 dpy = XOpenDisplay(NULL);
1354 if (dpy)
1355 {
1356 scrn_num = DefaultScreen(dpy);
1357 scrn = ScreenOfDisplay(dpy, scrn_num);
1358 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1359 24, XA_RGB_DEFAULT_MAP, False, True);
1360 printf("Status = %x\n", status);
1361 XCloseDisplay(dpy);
1362 }
1363 return 0;
1364}
1365EOF
1366 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1367 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1368 log_success "found"
1369 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1370 fi
1371}
1372
1373#
1374# Check for Mesa, needed by OpenGL
1375#
1376check_mesa()
1377{
1378 test_header "Mesa / GLU"
1379 cat > $ODIR.tmp_src.cc << EOF
1380#include <cstdio>
1381#include <X11/Xlib.h>
1382#include <GL/glx.h>
1383#include <GL/glu.h>
1384extern "C" int main(void)
1385{
1386 Display *dpy;
1387 int major, minor;
1388
1389 dpy = XOpenDisplay(NULL);
1390 if (dpy)
1391 {
1392 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1393 XCloseDisplay(dpy);
1394 if (glx_version)
1395 {
1396 printf("found version %u.%u, OK.\n", major, minor);
1397 return 0;
1398 }
1399 }
1400 printf("found (inactive), OK.\n");
1401 return 0;
1402}
1403EOF
1404 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1405 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1406 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1407 test_execute
1408 fi
1409}
1410
1411
1412#
1413# Check for the Qt4 library, needed by the VirtualBox frontend
1414#
1415# Currently not fatal.
1416#
1417check_qt4()
1418{
1419 foundqt4=
1420 test_header Qt4
1421 if [ "$OS" = "darwin" ]; then
1422 # First check if there is the internal version of Qt. If yes nothing else
1423 # has to be done.
1424 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1425 for t in $QT_INTERNAL; do
1426 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1427 cnf_append "VBOX_WITH_QT4_SUN" "1"
1428 log_success "use internal version"
1429 return
1430 fi
1431 done
1432 # Now try the user provided directory and some of the standard directories.
1433 QT_TRIES="$QT4DIR /System/Library /Library"
1434 for t in $QT_TRIES; do
1435 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1436 PATH_SDK_QT4="$t"
1437 break
1438 fi
1439 done
1440 # Add the necessary params for building the test application
1441 if [ -n "$PATH_SDK_QT4" ]; then
1442 foundqt4=1
1443 INCQT4=-I$PATH_SDK_QT4/Frameworks/QtCore.framework/Headers
1444 LIBQT4=-F$PATH_SDK_QT4/Frameworks
1445 FLGQT4="-framework QtCore"
1446 else
1447 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1448 fail
1449 fi
1450 else
1451 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1452 # default is to use pkg-config
1453 if which_wrapper pkg-config > /dev/null; then
1454 # this braindead path is necessary for mdv2008.1
1455 qt4_ver=`\
1456 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1457 pkg-config QtCore --modversion 2>> $LOG`
1458 if [ $? -ne 0 ]; then
1459 log_failure "not found"
1460 fail
1461 else
1462 FLGQT4=`\
1463 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1464 pkg-config QtCore --cflags`
1465 INCQT4=`strip_I "$FLGQT4"`
1466 LIBQT4=`\
1467 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1468 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1469 pkg-config QtCore --libs`
1470 foundqt4=1
1471 fi
1472 else
1473 log_failure "pkg-config not found"
1474 fail
1475 fi
1476 else
1477 # do it the old way (e.g. user has specified QT4DIR)
1478 cat > $ODIR.tmp_src.cc << EOF
1479#include <cstdio>
1480#include <QtGlobal>
1481extern "C" int main(void)
1482{
1483 printf("found version %s", QT_VERSION_STR);
1484#if QT_VERSION >= 0x040400
1485 printf(", OK.\n");
1486 return 0;
1487#else
1488 printf(", expected version 4.4.0 or higher\n");
1489 return 1;
1490#endif
1491}
1492EOF
1493 for q in $QT4DIR; do
1494 INCQT4="$q/include $q/include/QtCore"
1495 FLGQT4="-DQT_SHARED"
1496 I_INCQT4=`prefix_I "$INCQT4"`
1497 LIBQT4="-L$q/lib -lQtCoreVBox"
1498 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1499 foundqt4=2
1500 break;
1501 fi
1502 LIBQT4="-L$q/lib -lQtCore"
1503 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1504 foundqt4=1
1505 break;
1506 fi
1507 done
1508 fi
1509 fi
1510 if [ -n "$foundqt4" ]; then
1511 cat > $ODIR.tmp_src.cc << EOF
1512#include <cstdio>
1513#include <QtGlobal>
1514extern "C" int main(void)
1515{
1516 printf("found version %s", QT_VERSION_STR);
1517#if QT_VERSION >= 0x040400
1518 printf(", OK.\n");
1519 return 0;
1520#else
1521 printf(", expected version 4.4.0 or higher\n");
1522 return 1;
1523#endif
1524}
1525EOF
1526 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1527 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1528 if test_execute_path "`strip_L "$LIBQT4"`"; then
1529 if [ "$OS" = "darwin" ]; then
1530 # Successful build & run the test application so add the necessary
1531 # params to AutoConfig.kmk
1532 cnf_append "PATH_SDK_QT4_INC" "$PATH_SDK_QT4/Frameworks"
1533 cnf_append "PATH_SDK_QT4_LIB" "$PATH_SDK_QT4/Frameworks"
1534 cnf_append "PATH_SDK_QT4" "$PATH_SDK_QT4/Frameworks"
1535 # Check for the moc tool in the Qt directory found & some standard
1536 # directories.
1537 for q in $PATH_SDK_QT4 /usr /Developer/Tools/Qt; do
1538 if which_wrapper "$q/bin/moc" > /dev/null; then
1539 cnf_append "PATH_TOOL_QT4" "$q"
1540 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1541 fi
1542 done
1543 else
1544 # strip .../QtCore as we add components ourself
1545 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1546 # store only the first path, remove all other pathes
1547 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1548 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1549 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1550 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1551 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1552 # this is not quite right since the qt libpath does not have to be first...
1553 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1554 if [ "$foundqt4" = "2" ]; then
1555 cnf_append "VBOX_WITH_QT4_SUN" "1"
1556 fi
1557 test_header "Qt4 devtools"
1558 for q in $QT4DIR; do
1559 # first try it with a suffix, some platforms use that
1560 if which_wrapper "$q/bin/moc-qt4" > /dev/null; then
1561 moc_ver=`$q/bin/moc-qt4 -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1562 if [ $? -ne 0 ]; then
1563 log_failure "not found"
1564 fail
1565 else
1566 log_success "found version $moc_ver"
1567 cnf_append "VBOX_PATH_QT4" "$q"
1568 cnf_append "PATH_SDK_QT4" "$q"
1569 cnf_append "PATH_TOOL_QT4" "$q"
1570 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1571 cnf_append "TOOL_QT4_BIN_SUFF" "-qt4"
1572 return
1573 fi
1574 elif which_wrapper "$q/bin/moc" > /dev/null; then
1575 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1576 if [ $? -ne 0 ]; then
1577 log_failure "not found"
1578 fail
1579 else
1580 log_success "found version $moc_ver"
1581 cnf_append "VBOX_PATH_QT4" "$q"
1582 cnf_append "PATH_SDK_QT4" "$q"
1583 cnf_append "PATH_TOOL_QT4" "$q"
1584 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1585 return
1586 fi
1587 fi
1588 done
1589 fi
1590 fi
1591 else
1592 log_failure "not found"
1593 fail
1594 fi
1595 else
1596 log_failure "not found"
1597 fail
1598 fi
1599}
1600
1601
1602#
1603# Check whether static libstdc++ is installed. This library is required
1604# for the Linux guest additions.
1605#
1606check_staticlibstdcxx()
1607{
1608 test_header "static stc++ library"
1609 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1610 cat > $ODIR.tmp_src.cc << EOF
1611#include <string>
1612
1613extern "C" int main(void)
1614{
1615 std::string s = "test";
1616 return 0;
1617}
1618EOF
1619 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1620 log_success "found"
1621 fi
1622}
1623
1624
1625#
1626# Check for Linux sources
1627#
1628check_linux()
1629{
1630 test_header "Linux kernel sources"
1631 cat > $ODIR.tmp_src.c << EOF
1632#include <linux/version.h>
1633int printf(const char *format, ...);
1634int main(void)
1635{
1636 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1637 (LINUX_VERSION_CODE % 65536) / 256,
1638 LINUX_VERSION_CODE % 256);
1639#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1640 printf(", OK.\n");
1641 return 0;
1642#else
1643 printf(", expected version 2.4.0 or higher\n");
1644 return 1;
1645#endif
1646}
1647EOF
1648 echo "compiling the following source file:" >> $LOG
1649 cat $ODIR.tmp_src.c >> $LOG
1650 echo "using the following command line:" >> $LOG
1651 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1652 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1653 if [ $? -ne 0 ]; then
1654 echo
1655 echo " Linux kernel headers not found at $LINUX"
1656 echo " Check the file $LOG for detailed error information."
1657 fail
1658 else
1659 if test_execute; then
1660 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1661 fi
1662 fi
1663}
1664
1665
1666#
1667# Check for kchmviewer, needed to display the online help
1668# (unused as we ship kchmviewer)
1669#
1670check_kchmviewer()
1671{
1672 test_header kchmviewer
1673 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1674 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1675 if [ $? -ne 0 ]; then
1676 log_failure "not found"
1677 fail
1678 else
1679 log_success "found version $kchmviewer_ver"
1680 fi
1681 fi
1682}
1683
1684
1685#
1686# Check for the kBuild tools, we don't support GNU make
1687#
1688check_kbuild()
1689{
1690 test_header kBuild
1691 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1692 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1693 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1694 echo "export PATH_KBUILD" >> $ENV
1695 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1696 echo "export PATH_DEVTOOLS" >> $ENV
1697 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1698 echo "export PATH_KBUILD_BIN" >> $ENV
1699 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1700 if [ "$OS" = "solaris" ]; then
1701 # Because of sh being non-default shell in Solaris we need to export PATH again when
1702 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1703 echo "PATH=\"$ORGPATH\"" >> $ENV
1704 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1705 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1706 else
1707 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1708 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1709 fi
1710 echo "export PATH" >> $ENV
1711 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1712 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1713 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1714 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1715 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1716 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1717 echo "export PATH_KBUILD" >> $ENV
1718 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1719 echo "export PATH_DEVTOOLS" >> $ENV
1720 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1721 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1722 echo "export PATH_KBUILD_BIN" >> $ENV
1723 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1724 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1725 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1726 echo "export PATH" >> $ENV
1727 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1728 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1729 elif check_avail "kmk" KBUILDDIR really; then
1730 # check for installed kBuild
1731 KBUILD_SED="`which_wrapper kmk_sed`"
1732 else
1733 fail
1734 fi
1735 log_success "found"
1736}
1737
1738
1739#
1740# Check for compiler.h
1741# Some Linux distributions include "compiler.h" in their libc linux
1742# headers package, some don't. Most don't need it, building might (!)
1743# not succeed on openSUSE without it.
1744#
1745# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1746#
1747check_compiler_h()
1748{
1749 test_header compiler.h
1750 if ! test -f "/usr/include/linux/compiler.h"; then
1751 log_success "compiler.h not found"
1752 else
1753 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1754 log_success "compiler.h found"
1755 fi
1756}
1757
1758#
1759# Check for libcap.
1760# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1761# sockets for doing ICMP requests.
1762#
1763check_libcap()
1764{
1765 test_header "libcap library"
1766 cat > $ODIR.tmp_src.cc << EOF
1767#include <cstdio>
1768#include <sys/types.h>
1769#include <sys/capability.h>
1770
1771extern "C" int main(void)
1772{
1773 char buf[1024];
1774 cap_t caps = cap_get_proc();
1775 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1776 return 0;
1777}
1778EOF
1779 if test_compile $LIBCAP libcap libcap; then
1780 if test_execute; then
1781 log_success "found"
1782 fi
1783 fi
1784}
1785
1786#
1787# Check if we are able to build 32-bit applications (needed for the guest additions)
1788#
1789check_32bit()
1790{
1791 test_header "32-bit support"
1792 cat > $ODIR.tmp_src.c << EOF
1793#include <stdint.h>
1794int main(void)
1795{
1796 return 0;
1797}
1798EOF
1799 echo "compiling the following source file:" >> $LOG
1800 cat $ODIR.tmp_src.c >> $LOG
1801 echo "using the following command line:" >> $LOG
1802 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1803 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1804 if [ $? -ne 0 ]; then
1805 echo
1806 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1807 echo " Check the file $LOG for detailed error information."
1808 fail
1809 fi
1810 log_success ""
1811}
1812
1813
1814#
1815# Check for Python
1816#
1817check_python()
1818{
1819 test_header "Python support"
1820
1821 # On darwin this is a on/off decision only
1822 if [ "$OS" = "darwin" ]; then
1823 echo "enabled"
1824 cnf_append "VBOX_WITH_PYTHON" "1"
1825 return
1826 fi
1827
1828 cat > $ODIR.tmp_src.cc << EOF
1829#include <cstdio>
1830#include <Python.h>
1831extern "C" int main(void)
1832{
1833 Py_Initialize();
1834 printf("found version %s", PY_VERSION);
1835#if PY_VERSION_HEX >= 0x02030000
1836 printf(", OK.\n");
1837 return 0;
1838#else
1839 printf(", expected version 2.3 or higher\n");
1840 return 1;
1841#endif
1842}
1843EOF
1844 found=
1845# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1846 if [ "$OS" != "solaris" ]; then
1847 SUPPYTHONLIBS="python2.6 python2.5 python2.4 python2.3"
1848 else
1849 SUPPYTHONLIBS="python2.4"
1850 fi
1851 for p in $PYTHONDIR; do
1852 for d in $SUPPYTHONLIBS; do
1853 for b in lib64 lib/64 lib; do
1854 echo "compiling the following source file:" >> $LOG
1855 cat $ODIR.tmp_src.cc >> $LOG
1856 echo "using the following command line:" >> $LOG
1857 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1858 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1859 if [ $? -eq 0 ]; then
1860 found=1
1861 break
1862 fi
1863 done
1864 if [ -n "$found" ]; then break; fi
1865 done
1866 if [ -n "$found" ]; then break; fi
1867 done
1868 if [ -n "$found" ]; then
1869 if test_execute; then
1870 cnf_append "VBOX_WITH_PYTHON" "1"
1871 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1872 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1873 else
1874 log_failure "not found"
1875 fail
1876 fi
1877 else
1878 log_failure "not found"
1879 fail
1880 fi
1881}
1882
1883
1884#
1885# Check for Java
1886#
1887check_java()
1888{
1889 test_header "Java support"
1890 log_success
1891}
1892
1893
1894#
1895# Setup wine
1896#
1897setup_wine()
1898{
1899 test_header "Wine support"
1900 if ! which_wrapper wine > /dev/null; then
1901 echo " wine binary not found"
1902 fail
1903 fi
1904 if ! which_wrapper wineprefixcreate > /dev/null; then
1905 echo " wineprefixcreate not found"
1906 fail
1907 fi
1908 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1909 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1910 echo "export WINEPREFIX" >> $ENV
1911 rm -rf $WINEPREFIX
1912 mkdir -p $WINEPREFIX
1913 touch $WINEPREFIX/.no_prelaunch_window_flag
1914 if ! wineprefixcreate -q > /dev/null 2>&1; then
1915 echo " wineprefixcreate failed"
1916 fail
1917 fi
1918 tmp=.tmp.wine.reg
1919 rm -f $tmp
1920 echo 'REGEDIT4' > $tmp
1921 echo '' >> $tmp
1922 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1923 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1924 echo '' >> $tmp
1925 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1926 echo '"itss"="native"' >> $tmp
1927 echo '' >> $tmp
1928 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1929 echo '"itss"="native"' >> $tmp
1930 echo '' >> $tmp
1931 if ! wine regedit $tmp > /dev/null 2>&1; then
1932 rm -f $tmp
1933 echo " failed to load registry changes (path)."
1934 fail
1935 fi
1936 rm -f $tmp
1937 log_success "found"
1938}
1939
1940#
1941# Check for gSOAP.
1942#
1943check_gsoap()
1944{
1945 test_header "GSOAP compiler"
1946 if [ -z "$GSOAP" ]; then
1947 GSOAP="/usr"
1948 fi
1949 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
1950 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
1951 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
1952 # TODO: Check for libgsoap++.a/so
1953
1954 if [ -z "$GSOAP_IMPORT" ]; then
1955 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
1956 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
1957 GSOAP_IMPORT="$GSOAP/include/gsoap"
1958 fi
1959 fi
1960 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
1961 cnf_append "VBOX_GSOAP_INSTALLED" "1"
1962 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
1963 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
1964 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
1965 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
1966 else
1967 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
1968 fi
1969 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoap++"
1970 log_success "found"
1971 else
1972 log_failure "stlvector.h not found -- disabling webservice"
1973 cnf_append "VBOX_WITH_WEBSERVICES" ""
1974 fi
1975 else
1976 log_failure "stdsoap2.h not found -- disabling webservice"
1977 cnf_append "VBOX_WITH_WEBSERVICES" ""
1978 fi
1979 else
1980 log_failure "wsdl2h not found -- disabling webservice"
1981 cnf_append "VBOX_WITH_WEBSERVICES" ""
1982 fi
1983 else
1984 log_failure "soapcpp2 not found -- disabling webservice"
1985 cnf_append "VBOX_WITH_WEBSERVICES" ""
1986 fi
1987}
1988
1989
1990#
1991# Determines the Darwin version.
1992# @todo This should really check the Xcode/SDK version.
1993#
1994check_darwinversion()
1995{
1996 test_header "Darwin version"
1997 darwin_ver=`uname -r`
1998 case "$darwin_ver" in
1999 10\.*)
2000 darwin_ver="10.6"
2001 sdk=/Developer/SDKs/MacOSX10.5.sdk
2002 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2003# test "$CC" = "gcc" && CC="gcc-4.0"
2004# test "$CXX" = "g++" && CXX="g++-4.0"
2005 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2006 ;;
2007 9\.*)
2008 darwin_ver="10.5"
2009 sdk=/Developer/SDKs/MacOSX10.5.sdk
2010 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2011# test "$CC" = "gcc" && CC="gcc-4.0"
2012# test "$CXX" = "g++" && CXX="g++-4.0"
2013 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2014 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2015 ;;
2016 8\.*)
2017 darwin_ver="10.4"
2018 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2019 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2020# test "$CC" = "gcc" && CC="gcc-4.0"
2021# test "$CXX" = "g++" && CXX="g++-4.0"
2022 cnf_append "VBOX_WITH_COCOA_QT" ""
2023 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2024 ;;
2025 *)
2026 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2027 fail
2028 darwin_ver="unknown"
2029 ;;
2030 esac
2031 log_success "found version $darwin_ver (SDK: $sdk)"
2032}
2033
2034
2035#
2036# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
2037# is around to prevent confusion when the build fails in src/recompiler.
2038# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
2039#
2040check_i386elfgcc()
2041{
2042 test_header "i386-elf-gcc"
2043 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
2044 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
2045 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
2046 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
2047 if test -z "$i386_elf_gcc"; then
2048 echo " failed to find i386-elf-gcc"
2049 fail
2050 fi
2051 log_success "found $i386_elf_gcc"
2052}
2053
2054
2055#
2056# Show help
2057#
2058show_help()
2059{
2060cat << EOF
2061Usage: ./configure [OPTIONS]...
2062
2063Configuration:
2064 -h, --help display this help and exit
2065 --nofatal don't abort on errors
2066EOF
2067[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2068[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2069[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2070[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2071[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2072[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2073[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2074[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2075[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2076[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2077[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2078[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2079cat << EOF
2080 --disable-hardening don't be strict about /dev/vboxdrv access
2081 --build-libxml2 build libxml2 from sources
2082 --build-libxslt build libxslt from sources
2083EOF
2084[ $OSE -eq 0 ] && cat << EOF
2085 --build-libssl build openssl from sources
2086 --build-libcurl build libcurl from sources
2087EOF
2088[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2089cat << EOF
2090
2091Paths:
2092 --with-gcc=PATH location of the gcc compiler [$CC]
2093 --with-g++=PATH location of the g++ compiler [$CXX]
2094 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2095 --with-iasl=PATH location of the iasl compiler [$IASL]
2096 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
2097EOF
2098[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2099[ $WITH_QT4 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]"
2100[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2101[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2102[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2103cat << EOF
2104 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2105 --out-path=PATH the folder to which configuration and build output
2106 should go
2107
2108Build type:
2109 -d, --build-debug build with debugging symbols and assertions
2110 --build-profile build with profiling support
2111 --build-headless build headless (without any GUI frontend)
2112EOF
2113 exit 0
2114}
2115
2116
2117#
2118# The body.
2119#
2120
2121# test if we are OSE
2122if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB/USBProxyDevice.cpp" ]; then
2123 OSE=0
2124 # Set this as a reminder to print a log message once we know the path of the
2125 # log file
2126 NOT_OSE=1
2127fi
2128
2129# Change OS specific defaults; must be before all other stuff
2130if [ "$OS" = "darwin" ]; then
2131 WITH_SDL=0
2132 WITH_SDL_TTF=0
2133 WITH_X11=0
2134 WITH_ALSA=0
2135 WITH_PULSE=0
2136 WITH_DBUS=0
2137 WITH_KMODS=0
2138 BUILD_LIBXSLT=1
2139 BUILD_LIBXML2=1
2140 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2141 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2142fi
2143
2144
2145# scan command line options
2146for option in $*; do
2147 case "$option" in
2148 --help|-help|-h)
2149 show_help
2150 ;;
2151 --nofatal)
2152 nofatal=1
2153 ;;
2154 --env-only)
2155 ENV_ONLY=1
2156 ;;
2157 --with-gcc=*)
2158 CC=`echo $option | cut -d'=' -f2`
2159 ;;
2160 --with-g++=*)
2161 CXX=`echo $option | cut -d'=' -f2`
2162 ;;
2163 --with-kbuild=*)
2164 KBUILDDIR=`echo $option | cut -d'=' -f2`
2165 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2166 echo "Error: KBUILDDIR contains invalid characters!"
2167 exit 1
2168 fi
2169 ;;
2170 --with-qt-dir=*|--with-qt4-dir=*)
2171 QT4DIR=`echo $option | cut -d'=' -f2`
2172 QT4DIR_PKGCONFIG=0
2173 ;;
2174 --with-openssl-dir=*)
2175 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2176 INCCRYPTO="-I${OPENSSLDIR}/include"
2177 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a"
2178 ;;
2179 --with-gsoap-dir=*)
2180 GSOAP=`echo $option | cut -d'=' -f2`
2181 ;;
2182 --with-gsoap-import=*)
2183 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2184 ;;
2185 --with-iasl=*)
2186 IASL=`echo $option | cut -d'=' -f2`
2187 ;;
2188 --with-linux=*)
2189 LINUX=`echo $option | cut -d'=' -f2`
2190 ;;
2191 --with-mkisofs=*)
2192 MKISOFS=`echo $option | cut -d'=' -f2`
2193 ;;
2194 --target-arch=*)
2195 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2196 ;;
2197 --disable-xpcom)
2198 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2199 ;;
2200 --disable-python)
2201 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2202 ;;
2203 --disable-java)
2204 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2205 ;;
2206 --disable-vmmraw)
2207 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2208 ;;
2209 --disable-sdl-ttf)
2210 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2211 ;;
2212 --disable-qt)
2213 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2214 ;;
2215 --disable-qt4)
2216 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2217 ;;
2218 --passive-mesa)
2219 PASSIVE_MESA=1
2220 ;;
2221 --disable-alsa)
2222 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2223 ;;
2224 --disable-pulse)
2225 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2226 ;;
2227 --enable-pulse)
2228 WITH_PULSE=2
2229 ;;
2230 --disable-dbus)
2231 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2232 ;;
2233 --disable-kmods)
2234 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2235 ;;
2236 --disable-opengl)
2237 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2238 ;;
2239 --enable-webservice)
2240 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2241 ;;
2242 --disable-hardening)
2243 WITH_HARDENING=0
2244 ;;
2245 --enable-hardening)
2246 WITH_HARDENING=2
2247 ;;
2248 --enable-vde)
2249 WITH_VDE=1
2250 ;;
2251 --build-debug|-d)
2252 BUILD_TYPE=debug
2253 ;;
2254 --build-profile)
2255 BUILD_TYPE=profile
2256 ;;
2257 --build-libxml2)
2258 BUILD_LIBXML2=1
2259 ;;
2260 --build-libxslt)
2261 BUILD_LIBXSLT=1
2262 ;;
2263 --build-libssl)
2264 BUILD_LIBSSL=1
2265 ;;
2266 --build-libcurl)
2267 BUILD_LIBCURL=1
2268 ;;
2269 --build-headless)
2270 HEADLESS=1
2271 WITH_SDL=0
2272 WITH_SDL_TTF=0
2273 WITH_X11=0
2274 WITH_OPENGL=0
2275 WITH_QT4=0
2276 ;;
2277 --ose)
2278 OSE=2
2279 ;;
2280 --odir=*)
2281 ODIR="`echo $option | cut -d'=' -f2`/"
2282 ODIR_OVERRIDE=1
2283 ;;
2284 --out-path=*)
2285 out_path="`echo $option | cut -d'=' -f2`/"
2286 if [ -d $out_path ]; then
2287 saved_path="`pwd`"
2288 cd $out_path
2289 OUT_PATH="`pwd`"
2290 cd $saved_path
2291 OUT_PATH_OVERRIDE=1
2292 if [ $ODIR_OVERRIDE -eq 0 ]; then
2293 # This variable has not *yet* been overridden. That can still happen.
2294 ODIR=$OUT_PATH/
2295 fi
2296 else
2297 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2298 exit 1
2299 fi
2300 ;;
2301 --setup-wine)
2302 [ "$OS" != "darwin" ] && SETUP_WINE=1
2303 ;;
2304 *)
2305 echo
2306 echo "Unrecognized option \"$option\""
2307 echo
2308 show_help
2309 ;;
2310 esac
2311done
2312
2313LOG="$ODIR$LOG"
2314ENV="$ODIR$ENV"
2315CNF="$ODIR$CNF"
2316
2317# initialize output files
2318cat > $LOG << EOF
2319# Log file generated by
2320#
2321# '$0 $*'
2322#
2323
2324EOF
2325cat > $CNF << EOF
2326# -*- Makefile -*-
2327#
2328# automatically generated by
2329#
2330# '$0 $*'
2331#
2332# It will be completely overwritten if configure is executed again.
2333#
2334
2335EOF
2336cat > $ENV << EOF
2337#!/bin/bash
2338#
2339# automatically generated by
2340#
2341# '$0 $*'
2342#
2343# It will be completely overwritten if configure is executed again.
2344# Make sure you source this file once before you start to build VBox.
2345#
2346
2347EOF
2348
2349# Print log warning about OSE if necessary
2350if [ -n "$NOT_OSE" ]; then
2351 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
2352 echo >> $LOG
2353fi
2354
2355
2356if [ "$BUILD_TYPE" = "debug" ]; then
2357 echo "Creating DEBUG build!" >> $LOG
2358elif [ "$BUILD_TYPE" = "profile" ]; then
2359 echo "Creating PROFILE build!" >> $LOG
2360fi
2361
2362# first determine our environment
2363check_environment
2364check_kbuild
2365
2366[ -n "$ENV_ONLY" ] && exit 0
2367
2368# append the tools directory to the default search path
2369echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2370export PATH
2371
2372# if we will be writing to a different out directory then set this up now
2373if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2374 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2375 echo "export AUTOCFG" >> $ENV
2376 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2377 echo "export LOCALCFG" >> $ENV
2378 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2379 echo "export PATH_OUT_BASE" >> $ENV
2380fi
2381
2382# some things are not available in for OSE
2383if [ $OSE -ge 1 ]; then
2384 cnf_append "VBOX_OSE" "1"
2385 cnf_append "VBOX_WITH_TESTSUITE" ""
2386 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2387
2388 if [ "$OS" = "linux" ]; then
2389 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2390 else
2391 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2392 fi
2393 echo >> $CNF
2394fi
2395
2396# headless
2397if [ -n "$HEADLESS" ]; then
2398 cnf_append "VBOX_HEADLESS" "1"
2399fi
2400
2401# emit disable directives corresponding to any --disable-xxx options.
2402if [ $WITH_OPENGL -eq 0 ]; then
2403 cnf_append "VBOX_WITH_CROGL" ""
2404 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2405 cnf_append "VBOX_GUI_USE_QGL" ""
2406fi
2407[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2408[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2409[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2410[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2411[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2412[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2413[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2414[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2415
2416# Darwin-specific
2417if [ "$OS" = "darwin" ]; then
2418 check_darwinversion
2419fi
2420# the tools
2421check_gcc
2422[ "$OS" != "darwin" ] && check_as86
2423[ "$OS" != "darwin" ] && check_bcc
2424[ "$OS" != "darwin" ] && check_iasl
2425# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2426# [ "$OS" != "darwin" ] && check_yasm
2427[ "$OS" != "darwin" ] && check_xsltproc
2428[ $OSE -eq 0 -a "$OS" != "darwin" ] && check_mkisofs
2429
2430# the libraries
2431[ "$OS" != "darwin" ] && check_pthread
2432check_libxml2
2433[ $WITH_XPCOM -eq 1 ] && check_libxslt
2434[ $WITH_LIBIDL -eq 1 ] && check_libidl
2435check_ssl
2436check_curl
2437[ "$OS" != "darwin" ] && check_z
2438[ "$OS" != "darwin" -a "$OS" != "freebsd" ] && check_png
2439[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2440[ $WITH_SDL -eq 1 ] && check_sdl
2441[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2442[ $WITH_X11 -eq 1 ] && check_x
2443# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2444# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2445[ $WITH_X11 -eq 1 ] && check_xcursor
2446[ $WITH_X11 -eq 1 ] && check_xinerama
2447[ $WITH_X11 -eq 1 ] && check_xrandr
2448[ $WITH_OPENGL -eq 1 ] && check_opengl
2449[ $WITH_QT4 -eq 1 ] && check_qt4
2450[ $WITH_PYTHON -eq 1 ] && check_python
2451[ $WITH_JAVA -eq 1 ] && check_java
2452
2453# PulseAudio
2454if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2455 if [ $WITH_PULSE -eq 1 ]; then
2456 check_pulse
2457 elif [ $WITH_PULSE -eq 0 ]; then
2458 cnf_append "VBOX_WITH_PULSE" ""
2459 fi
2460fi
2461
2462# Linux-specific
2463if [ "$OS" = "linux" ]; then
2464 # don't check for the static libstdc++ in the PUEL version as we build the
2465 # additions at a dedicated box
2466 [ $OSE -ge 1 ] && check_staticlibstdcxx
2467 if [ $WITH_KMODS -eq 1 ]; then
2468 check_linux
2469 else
2470 cnf_append "VBOX_LINUX_SRC" ""
2471 cnf_append "VBOX_WITH_VBOXDRV" ""
2472 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2473 fi
2474 if [ $WITH_ALSA -eq 1 ]; then
2475 check_alsa
2476 else
2477 cnf_append "VBOX_WITH_ALSA" ""
2478 fi
2479 if [ $WITH_DBUS -eq 0 ]; then
2480 cnf_append "VBOX_WITH_DBUS" ""
2481 fi
2482 check_libcap
2483 check_compiler_h
2484 [ "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2485fi
2486
2487[ -n "$SETUP_WINE" ] && setup_wine
2488
2489if [ $OSE -ge 1 ]; then
2490 if [ $WITH_GSOAP -eq 1 ]; then
2491 check_gsoap
2492 else
2493 cnf_append "VBOX_WITH_WEBSERVICES" ""
2494 fi
2495fi
2496
2497# VDE
2498if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2499 if [ $WITH_VDE -eq 1 ]; then
2500 cnf_append "VBOX_WITH_VDE" "1"
2501 fi
2502fi
2503
2504# success!
2505echo
2506echo "Successfully generated '$CNF' and '$ENV'."
2507echo "Source '$ENV' once before you start to build VBox:"
2508echo ""
2509echo " source $ENV"
2510echo " kmk"
2511echo ""
2512if [ "$OS" = "linux" ]; then
2513 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2514 vbox_out_path=$OUT_PATH
2515 else
2516 vbox_out_path=./out
2517 fi
2518 echo "To compile the kernel modules, do:"
2519 echo ""
2520 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2521 echo " make"
2522 echo ""
2523fi
2524if [ $WITH_HARDENING -gt 0 ]; then
2525 echo ""
2526 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2527 echo " Hardening is enabled which means that the VBox binaries will not run from"
2528 echo " the binary directory. The binaries have to be installed suid root and some"
2529 echo " more prerequisites have to be fulfilled which is normally done by installing"
2530 echo " the final package. For development, the hardening feature can be disabled"
2531 echo " by specifying the --disable-hardening parameter. Please never disable that"
2532 echo " feature for the final distribution!"
2533 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2534 echo ""
2535else
2536 echo ""
2537 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2538 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2539 echo " disabled hardening!"
2540 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2541 echo ""
2542fi
2543echo "Enjoy!"
2544cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use